## Enumerations and Flags Enumerations and Flags — Common enumeration and flag types. |

## Functions

const gchar * | mbim_device_type_get_string ()
gchar * | mbim_cellular_class_build_string_from_mask ()
const gchar * | mbim_voice_class_get_string ()
gchar * | mbim_sim_class_build_string_from_mask ()
gchar * | mbim_data_class_build_string_from_mask ()
gchar * | mbim_sms_caps_build_string_from_mask ()
gchar * | mbim_ctrl_caps_build_string_from_mask ()
const gchar * | mbim_subscriber_ready_state_get_string ()
gchar * | mbim_ready_info_flag_build_string_from_mask ()
const gchar * | mbim_radio_switch_state_get_string ()
const gchar * | mbim_pin_type_get_string ()
const gchar * | mbim_pin_state_get_string ()
const gchar * | mbim_pin_operation_get_string ()
const gchar * | mbim_pin_mode_get_string ()
const gchar * | mbim_pin_format_get_string ()
gchar * | mbim_provider_state_build_string_from_mask ()
const gchar * | mbim_visible_providers_action_get_string ()
const gchar * | mbim_nw_error_get_string ()
const gchar * | mbim_register_action_get_string ()
const gchar * | mbim_register_state_get_string ()
const gchar * | mbim_register_mode_get_string ()
const gchar * | mbim_packet_service_action_get_string ()
const gchar * | mbim_packet_service_state_get_string ()
const gchar * | mbim_activation_command_get_string ()
const gchar * | mbim_compression_get_string ()
const gchar * | mbim_auth_protocol_get_string ()
const gchar * | mbim_context_ip_type_get_string ()
const gchar * | mbim_activation_state_get_string ()
const gchar * | mbim_voice_call_state_get_string ()
gchar * | mbim_ip_configuration_available_flag_build_string_from_mask ()
const gchar * | mbim_sms_storage_state_get_string ()
const gchar * | mbim_sms_format_get_string ()
const gchar * | mbim_sms_flag_get_string ()
const gchar * | mbim_sms_cdma_lang_get_string ()
const gchar * | mbim_sms_cdma_encoding_get_string ()
const gchar * | mbim_sms_status_get_string ()
const gchar * | mbim_sms_status_flag_get_string ()
const gchar * | mbim_ussd_action_get_string ()
const gchar * | mbim_ussd_response_get_string ()
const gchar * | mbim_ussd_session_state_get_string ()
const gchar * | mbim_phonebook_flag_get_string ()
const gchar * | mbim_phonebook_state_get_string ()
const gchar * | mbim_phonebook_write_flag_get_string ()
const gchar * | mbim_stk_pac_profile_get_string ()
const gchar * | mbim_stk_pac_type_get_string ()
const gchar * | mbim_network_idle_hint_state_get_string ()
const gchar * | mbim_emergency_mode_state_get_string ()
const gchar * | mbim_dss_link_state_get_string ()
const gchar * | mbim_atds_provider_plmn_mode_get_string ()
const gchar * | mbim_atds_rat_mode_get_string ()
const gchar * | mbim_pco_type_get_string ()
const gchar * | mbim_context_source_get_string ()
const gchar * | mbim_lte_attach_context_operation_get_string ()
const gchar * | mbim_lte_attach_context_roaming_control_get_string ()
const gchar * | mbim_lte_attach_state_get_string ()
const gchar * | mbim_sar_backoff_state_get_string ()
const gchar * | mbim_sar_control_mode_get_string ()
const gchar * | mbim_sar_wifi_hardware_state_get_string ()
const gchar * | mbim_transmission_notification_status_get_string ()
const gchar * | mbim_transmission_state_get_string ()
const gchar * | mbim_qdu_file_type_get_string ()
const gchar * | mbim_qdu_session_action_get_string ()
const gchar * | mbim_qdu_session_result_get_string ()
const gchar * | mbim_qdu_session_status_get_string ()
const gchar * | mbim_qdu_session_type_get_string ()
const gchar * | mbim_uicc_slot_state_get_string ()
const gchar * | mbim_uicc_secure_messaging_get_string ()
const gchar * | mbim_uicc_class_byte_type_get_string ()
const gchar * | mbim_uicc_pass_through_action_get_string ()
const gchar * | mbim_uicc_pass_through_status_get_string ()
const gchar * | mbim_quectel_radio_switch_state_get_string ()

## Types and Values

enum | MbimAtdsProviderPlmnMode
enum | MbimAtdsRatMode
enum | MbimDeviceType
enum | MbimCellularClass
enum | MbimVoiceClass
enum | MbimSimClass
enum | MbimDataClass
enum | MbimSmsCaps
enum | MbimCtrlCaps
enum | MbimSubscriberReadyState
enum | MbimReadyInfoFlag
enum | MbimRadioSwitchState
enum | MbimPinType
enum | MbimPinState
enum | MbimPinOperation
enum | MbimPinMode
enum | MbimPinFormat
enum | MbimProviderState
enum | MbimVisibleProvidersAction
enum | MbimNwError
enum | MbimRegisterAction
enum | MbimRegisterState
enum | MbimRegisterMode
enum | MbimRegistrationFlag
enum | MbimPacketServiceAction
enum | MbimPacketServiceState
enum | MbimActivationCommand
enum | MbimCompression
enum | MbimAuthProtocol
enum | MbimContextIpType
enum | MbimActivationState
enum | MbimVoiceCallState
enum | MbimIPConfigurationAvailableFlag
enum | MbimSmsStorageState
enum | MbimSmsFormat
enum | MbimSmsFlag
enum | MbimSmsCdmaLang
enum | MbimSmsCdmaEncoding
enum | MbimSmsStatus
enum | MbimSmsStatusFlag
enum | MbimUssdAction
enum | MbimUssdResponse
enum | MbimUssdSessionState
enum | MbimPhonebookFlag
enum | MbimPhonebookState
enum | MbimPhonebookWriteFlag
enum | MbimStkPacProfile
enum | MbimStkPacType
enum | MbimNetworkIdleHintState
enum | MbimEmergencyModeState
enum | MbimDssLinkState
enum | MbimQduFileType
enum | MbimQduSessionAction
enum | MbimQduSessionType
enum | MbimQduSessionStatus
enum | MbimQduSessionResult
enum | MbimPcoType
enum | MbimContextSource
enum | MbimLteAttachContextOperation
enum | MbimLteAttachContextRoamingControl
enum | MbimLteAttachState
enum | MbimSarBackoffState
enum | MbimSarControlMode
enum | MbimSarWifiHardwareState
enum | MbimTransmissionNotificationStatus
enum | MbimTransmissionState
enum | MbimUiccSlotState
enum | MbimUiccSecureMessaging
enum | MbimUiccClassByteType
enum | MbimUiccPassThroughAction
enum | MbimUiccPassThroughStatus
enum | MbimQuectelRadioSwitchState

## Object Hierarchy

        GEnum
        ├── MbimActivationCommand
        ├── MbimActivationState
        ├── MbimAtdsProviderPlmnMode
        ├── MbimAtdsRatMode
        ├── MbimAuthProtocol
        ├── MbimCompression
        ├── MbimContextIpType
        ├── MbimContextSource
        ├── MbimDeviceType
        ├── MbimDssLinkState
        ├── MbimEmergencyModeState
        ├── MbimLteAttachContextOperation
        ├── MbimLteAttachContextRoamingControl
        ├── MbimLteAttachState
        ├── MbimNetworkIdleHintState
        ├── MbimNwError
        ├── MbimPacketServiceAction
        ├── MbimPacketServiceState
        ├── MbimPcoType
        ├── MbimPhonebookFlag
        ├── MbimPhonebookState
        ├── MbimPhonebookWriteFlag
        ├── MbimPinFormat
        ├── MbimPinMode
        ├── MbimPinOperation
        ├── MbimPinState
        ├── MbimPinType
        ├── MbimQduFileType
        ├── MbimQduSessionAction
        ├── MbimQduSessionResult
        ├── MbimQduSessionStatus
        ├── MbimQduSessionType
        ├── MbimQuectelRadioSwitchState
        ├── MbimRadioSwitchState
        ├── MbimRegisterAction
        ├── MbimRegisterMode
        ├── MbimRegisterState
        ├── MbimSarBackoffState
        ├── MbimSarControlMode
        ├── MbimSarWifiHardwareState
        ├── MbimSmsCdmaEncoding
        ├── MbimSmsCdmaLang
        ├── MbimSmsFlag
        ├── MbimSmsFormat
        ├── MbimSmsStatus
        ├── MbimSmsStatusFlag
        ├── MbimSmsStorageState
        ├── MbimStkPacProfile
        ├── MbimStkPacType
        ├── MbimSubscriberReadyState
        ├── MbimTransmissionNotificationStatus
        ├── MbimTransmissionState
        ├── MbimUiccClassByteType
        ├── MbimUiccPassThroughAction
        ├── MbimUiccPassThroughStatus
        ├── MbimUiccSecureMessaging
        ├── MbimUiccSlotState
        ├── MbimUssdAction
        ├── MbimUssdResponse
        ├── MbimUssdSessionState
        ├── MbimVisibleProvidersAction
        ├── MbimVoiceCallState
        ╰── MbimVoiceClass
        GFlags
        ├── MbimCellularClass
        ├── MbimCtrlCaps
        ├── MbimDataClass
        ├── MbimIPConfigurationAvailableFlag
        ├── MbimProviderState
        ├── MbimReadyInfoFlag
        ├── MbimRegistrationFlag
        ├── MbimSimClass
        ╰── MbimSmsCaps

## Description

This section defines common enum and flag types used in the interface.

## Functions

### mbim_device_type_get_string ()

    const gchar *
    mbim_device_type_get_string (MbimDeviceType val);

Gets the nickname string for the MbimDeviceType specified at `val` .

#### Parameters

val | a MbimDeviceType. |

#### Returns

a string with the nickname, or `NULL` if not found. Do not free the returned value.

[transfer none]

Since: 1.0

### mbim_cellular_class_build_string_from_mask ()

    gchar *
    mbim_cellular_class_build_string_from_mask
                                   (MbimCellularClass mask);

Builds a string containing a comma-separated list of nicknames for each MbimCellularClass in `mask` .

#### Parameters

mask | bitmask of MbimCellularClass values. |

#### Returns

a string with the list of nicknames, or `NULL` if none given. The returned value should be freed with `g_free()`.

[transfer full]

Since: 1.0

### mbim_voice_class_get_string ()

    const gchar *
    mbim_voice_class_get_string (MbimVoiceClass val);

Gets the nickname string for the MbimVoiceClass specified at `val` .

#### Parameters

val | a MbimVoiceClass. |

#### Returns

a string with the nickname, or `NULL` if not found. Do not free the returned value.

[transfer none]

Since: 1.0

### mbim_sim_class_build_string_from_mask ()

    gchar *
    mbim_sim_class_build_string_from_mask (MbimSimClass mask);

Builds a string containing a comma-separated list of nicknames for each MbimSimClass in `mask` .

#### Parameters

mask | bitmask of MbimSimClass values. |

#### Returns

a string with the list of nicknames, or `NULL` if none given. The returned value should be freed with `g_free()`.

[transfer full]

Since: 1.0

### mbim_data_class_build_string_from_mask ()

    gchar *
    mbim_data_class_build_string_from_mask
                                   (MbimDataClass mask);

Builds a string containing a comma-separated list of nicknames for each MbimDataClass in `mask` .

#### Parameters

mask | bitmask of MbimDataClass values. |

#### Returns

a string with the list of nicknames, or `NULL` if none given. The returned value should be freed with `g_free()`.

[transfer full]

Since: 1.0

### mbim_sms_caps_build_string_from_mask ()

    gchar *
    mbim_sms_caps_build_string_from_mask (MbimSmsCaps mask);

Builds a string containing a comma-separated list of nicknames for each MbimSmsCaps in `mask` .

#### Parameters

mask | bitmask of MbimSmsCaps values. |

#### Returns

a string with the list of nicknames, or `NULL` if none given. The returned value should be freed with `g_free()`.

[transfer full]

Since: 1.0

### mbim_ctrl_caps_build_string_from_mask ()

    gchar *
    mbim_ctrl_caps_build_string_from_mask (MbimCtrlCaps mask);

Builds a string containing a comma-separated list of nicknames for each MbimCtrlCaps in `mask` .

#### Parameters

mask | bitmask of MbimCtrlCaps values. |

#### Returns

a string with the list of nicknames, or `NULL` if none given. The returned value should be freed with `g_free()`.

[transfer full]

Since: 1.0

### mbim_subscriber_ready_state_get_string ()

    const gchar *
    mbim_subscriber_ready_state_get_string
                                   (MbimSubscriberReadyState val);

Gets the nickname string for the MbimSubscriberReadyState specified at `val` .

#### Parameters

val | a MbimSubscriberReadyState. |

#### Returns

a string with the nickname, or `NULL` if not found. Do not free the returned value.

[transfer none]

Since: 1.0

### mbim_ready_info_flag_build_string_from_mask ()

    gchar *
    mbim_ready_info_flag_build_string_from_mask
                                   (MbimReadyInfoFlag mask);

Builds a string containing a comma-separated list of nicknames for each MbimReadyInfoFlag in `mask` .

#### Parameters

mask | bitmask of MbimReadyInfoFlag values. |

#### Returns

a string with the list of nicknames, or `NULL` if none given. The returned value should be freed with `g_free()`.

[transfer full]

Since: 1.0

### mbim_radio_switch_state_get_string ()

    const gchar *
    mbim_radio_switch_state_get_string (MbimRadioSwitchState val);

Gets the nickname string for the MbimRadioSwitchState specified at `val` .

#### Parameters

val | a MbimRadioSwitchState. |

#### Returns

a string with the nickname, or `NULL` if not found. Do not free the returned value.

[transfer none]

Since: 1.0

### mbim_pin_type_get_string ()

    const gchar *
    mbim_pin_type_get_string (MbimPinType val);

Gets the nickname string for the MbimPinType specified at `val` .

#### Parameters

val | a MbimPinType. |

#### Returns

a string with the nickname, or `NULL` if not found. Do not free the returned value.

[transfer none]

Since: 1.0

### mbim_pin_state_get_string ()

    const gchar *
    mbim_pin_state_get_string (MbimPinState val);

Gets the nickname string for the MbimPinState specified at `val` .

#### Parameters

val | a MbimPinState. |

#### Returns

a string with the nickname, or `NULL` if not found. Do not free the returned value.

[transfer none]

Since: 1.0

### mbim_pin_operation_get_string ()

    const gchar *
    mbim_pin_operation_get_string (MbimPinOperation val);

Gets the nickname string for the MbimPinOperation specified at `val` .

#### Parameters

val | a MbimPinOperation. |

#### Returns

a string with the nickname, or `NULL` if not found. Do not free the returned value.

[transfer none]

Since: 1.0

### mbim_pin_mode_get_string ()

    const gchar *
    mbim_pin_mode_get_string (MbimPinMode val);

Gets the nickname string for the MbimPinMode specified at `val` .

#### Parameters

val | a MbimPinMode. |

#### Returns

a string with the nickname, or `NULL` if not found. Do not free the returned value.

[transfer none]

Since: 1.0

### mbim_pin_format_get_string ()

    const gchar *
    mbim_pin_format_get_string (MbimPinFormat val);

Gets the nickname string for the MbimPinFormat specified at `val` .

#### Parameters

val | a MbimPinFormat. |

#### Returns

a string with the nickname, or `NULL` if not found. Do not free the returned value.

[transfer none]

Since: 1.0

### mbim_provider_state_build_string_from_mask ()

    gchar *
    mbim_provider_state_build_string_from_mask
                                   (MbimProviderState mask);

Builds a string containing a comma-separated list of nicknames for each MbimProviderState in `mask` .

#### Parameters

mask | bitmask of MbimProviderState values. |

#### Returns

a string with the list of nicknames, or `NULL` if none given. The returned value should be freed with `g_free()`.

[transfer full]

Since: 1.2

### mbim_visible_providers_action_get_string ()

    const gchar *
    mbim_visible_providers_action_get_string
                                   (MbimVisibleProvidersAction val);

Gets the nickname string for the MbimVisibleProvidersAction specified at `val` .

#### Parameters

val | a MbimVisibleProvidersAction. |

#### Returns

a string with the nickname, or `NULL` if not found. Do not free the returned value.

[transfer none]

Since: 1.2

### mbim_nw_error_get_string ()

    const gchar *
    mbim_nw_error_get_string (MbimNwError val);

Gets the nickname string for the MbimNwError specified at `val` .

#### Parameters

val | a MbimNwError. |

#### Returns

a string with the nickname, or `NULL` if not found. Do not free the returned value.

[transfer none]

Since: 1.0

### mbim_register_action_get_string ()

    const gchar *
    mbim_register_action_get_string (MbimRegisterAction val);

Gets the nickname string for the MbimRegisterAction specified at `val` .

#### Parameters

val | a MbimRegisterAction. |

#### Returns

a string with the nickname, or `NULL` if not found. Do not free the returned value.

[transfer none]

Since: 1.0

### mbim_register_state_get_string ()

    const gchar *
    mbim_register_state_get_string (MbimRegisterState val);

Gets the nickname string for the MbimRegisterState specified at `val` .

#### Parameters

val | a MbimRegisterState. |

#### Returns

a string with the nickname, or `NULL` if not found. Do not free the returned value.

[transfer none]

Since: 1.0

### mbim_register_mode_get_string ()

    const gchar *
    mbim_register_mode_get_string (MbimRegisterMode val);

Gets the nickname string for the MbimRegisterMode specified at `val` .

#### Parameters

val | a MbimRegisterMode. |

#### Returns

a string with the nickname, or `NULL` if not found. Do not free the returned value.

[transfer none]

Since: 1.0

### mbim_packet_service_action_get_string ()

    const gchar *
    mbim_packet_service_action_get_string (MbimPacketServiceAction val);

Gets the nickname string for the MbimPacketServiceAction specified at `val` .

#### Parameters

val | a MbimPacketServiceAction. |

#### Returns

a string with the nickname, or `NULL` if not found. Do not free the returned value.

[transfer none]

Since: 1.0

### mbim_packet_service_state_get_string ()

    const gchar *
    mbim_packet_service_state_get_string (MbimPacketServiceState val);

Gets the nickname string for the MbimPacketServiceState specified at `val` .

#### Parameters

val | a MbimPacketServiceState. |

#### Returns

a string with the nickname, or `NULL` if not found. Do not free the returned value.

[transfer none]

Since: 1.0

### mbim_activation_command_get_string ()

    const gchar *
    mbim_activation_command_get_string (MbimActivationCommand val);

Gets the nickname string for the MbimActivationCommand specified at `val` .

#### Parameters

val | a MbimActivationCommand. |

#### Returns

a string with the nickname, or `NULL` if not found. Do not free the returned value.

[transfer none]

Since: 1.0

### mbim_compression_get_string ()

    const gchar *
    mbim_compression_get_string (MbimCompression val);

Gets the nickname string for the MbimCompression specified at `val` .

#### Parameters

val | a MbimCompression. |

#### Returns

a string with the nickname, or `NULL` if not found. Do not free the returned value.

[transfer none]

Since: 1.0

### mbim_auth_protocol_get_string ()

    const gchar *
    mbim_auth_protocol_get_string (MbimAuthProtocol val);

Gets the nickname string for the MbimAuthProtocol specified at `val` .

#### Parameters

val | a MbimAuthProtocol. |

#### Returns

a string with the nickname, or `NULL` if not found. Do not free the returned value.

[transfer none]

Since: 1.0

### mbim_context_ip_type_get_string ()

    const gchar *
    mbim_context_ip_type_get_string (MbimContextIpType val);

Gets the nickname string for the MbimContextIpType specified at `val` .

#### Parameters

val | a MbimContextIpType. |

#### Returns

a string with the nickname, or `NULL` if not found. Do not free the returned value.

[transfer none]

Since: 1.0

### mbim_activation_state_get_string ()

    const gchar *
    mbim_activation_state_get_string (MbimActivationState val);

Gets the nickname string for the MbimActivationState specified at `val` .

#### Parameters

val | a MbimActivationState. |

#### Returns

a string with the nickname, or `NULL` if not found. Do not free the returned value.

[transfer none]

Since: 1.0

### mbim_voice_call_state_get_string ()

    const gchar *
    mbim_voice_call_state_get_string (MbimVoiceCallState val);

Gets the nickname string for the MbimVoiceCallState specified at `val` .

#### Parameters

val | a MbimVoiceCallState. |

#### Returns

a string with the nickname, or `NULL` if not found. Do not free the returned value.

[transfer none]

Since: 1.0

### mbim_ip_configuration_available_flag_build_string_from_mask ()

    gchar *
    mbim_ip_configuration_available_flag_build_string_from_mask
                                   (MbimIPConfigurationAvailableFlag mask);

Builds a string containing a comma-separated list of nicknames for each MbimIPConfigurationAvailableFlag in `mask` .

#### Parameters

mask | bitmask of MbimIPConfigurationAvailableFlag values. |

#### Returns

a string with the list of nicknames, or `NULL` if none given. The returned value should be freed with `g_free()`.

[transfer full]

Since: 1.0

### mbim_sms_storage_state_get_string ()

    const gchar *
    mbim_sms_storage_state_get_string (MbimSmsStorageState val);

Gets the nickname string for the MbimSmsStorageState specified at `val` .

#### Parameters

val | a MbimSmsStorageState. |

#### Returns

a string with the nickname, or `NULL` if not found. Do not free the returned value.

[transfer none]

Since: 1.4

### mbim_sms_format_get_string ()

    const gchar *
    mbim_sms_format_get_string (MbimSmsFormat val);

Gets the nickname string for the MbimSmsFormat specified at `val` .

#### Parameters

val | a MbimSmsFormat. |

#### Returns

a string with the nickname, or `NULL` if not found. Do not free the returned value.

[transfer none]

Since: 1.4

### mbim_sms_flag_get_string ()

    const gchar *
    mbim_sms_flag_get_string (MbimSmsFlag val);

Gets the nickname string for the MbimSmsFlag specified at `val` .

#### Parameters

val | a MbimSmsFlag. |

#### Returns

a string with the nickname, or `NULL` if not found. Do not free the returned value.

[transfer none]

Since: 1.4

### mbim_sms_cdma_lang_get_string ()

    const gchar *
    mbim_sms_cdma_lang_get_string (MbimSmsCdmaLang val);

Gets the nickname string for the MbimSmsCdmaLang specified at `val` .

#### Parameters

val | a MbimSmsCdmaLang. |

#### Returns

a string with the nickname, or `NULL` if not found. Do not free the returned value.

[transfer none]

Since: 1.4

### mbim_sms_cdma_encoding_get_string ()

    const gchar *
    mbim_sms_cdma_encoding_get_string (MbimSmsCdmaEncoding val);

Gets the nickname string for the MbimSmsCdmaEncoding specified at `val` .

#### Parameters

val | a MbimSmsCdmaEncoding. |

#### Returns

a string with the nickname, or `NULL` if not found. Do not free the returned value.

[transfer none]

Since: 1.4

### mbim_sms_status_get_string ()

    const gchar *
    mbim_sms_status_get_string (MbimSmsStatus val);

Gets the nickname string for the MbimSmsStatus specified at `val` .

#### Parameters

val | a MbimSmsStatus. |

#### Returns

a string with the nickname, or `NULL` if not found. Do not free the returned value.

[transfer none]

Since: 1.4

### mbim_sms_status_flag_get_string ()

    const gchar *
    mbim_sms_status_flag_get_string (MbimSmsStatusFlag val);

Gets the nickname string for the MbimSmsStatusFlag specified at `val` .

#### Parameters

val | a MbimSmsStatusFlag. |

#### Returns

a string with the nickname, or `NULL` if not found. Do not free the returned value.

[transfer none]

Since: 1.4

### mbim_ussd_action_get_string ()

    const gchar *
    mbim_ussd_action_get_string (MbimUssdAction val);

Gets the nickname string for the MbimUssdAction specified at `val` .

#### Parameters

val | a MbimUssdAction. |

#### Returns

a string with the nickname, or `NULL` if not found. Do not free the returned value.

[transfer none]

Since: 1.4

### mbim_ussd_response_get_string ()

    const gchar *
    mbim_ussd_response_get_string (MbimUssdResponse val);

Gets the nickname string for the MbimUssdResponse specified at `val` .

#### Parameters

val | a MbimUssdResponse. |

#### Returns

a string with the nickname, or `NULL` if not found. Do not free the returned value.

[transfer none]

Since: 1.4

### mbim_ussd_session_state_get_string ()

    const gchar *
    mbim_ussd_session_state_get_string (MbimUssdSessionState val);

Gets the nickname string for the MbimUssdSessionState specified at `val` .

#### Parameters

val | a MbimUssdSessionState. |

#### Returns

a string with the nickname, or `NULL` if not found. Do not free the returned value.

[transfer none]

Since: 1.4

### mbim_phonebook_flag_get_string ()

    const gchar *
    mbim_phonebook_flag_get_string (MbimPhonebookFlag val);

Gets the nickname string for the MbimPhonebookFlag specified at `val` .

#### Parameters

val | a MbimPhonebookFlag. |

#### Returns

a string with the nickname, or `NULL` if not found. Do not free the returned value.

[transfer none]

Since: 1.4

### mbim_phonebook_state_get_string ()

    const gchar *
    mbim_phonebook_state_get_string (MbimPhonebookState val);

Gets the nickname string for the MbimPhonebookState specified at `val` .

#### Parameters

val | a MbimPhonebookState. |

#### Returns

a string with the nickname, or `NULL` if not found. Do not free the returned value.

[transfer none]

Since: 1.4

### mbim_phonebook_write_flag_get_string ()

    const gchar *
    mbim_phonebook_write_flag_get_string (MbimPhonebookWriteFlag val);

Gets the nickname string for the MbimPhonebookWriteFlag specified at `val` .

#### Parameters

val | a MbimPhonebookWriteFlag. |

#### Returns

a string with the nickname, or `NULL` if not found. Do not free the returned value.

[transfer none]

Since: 1.4

### mbim_stk_pac_profile_get_string ()

    const gchar *
    mbim_stk_pac_profile_get_string (MbimStkPacProfile val);

Gets the nickname string for the MbimStkPacProfile specified at `val` .

#### Parameters

val | a MbimStkPacProfile. |

#### Returns

a string with the nickname, or `NULL` if not found. Do not free the returned value.

[transfer none]

Since: 1.4

### mbim_stk_pac_type_get_string ()

    const gchar *
    mbim_stk_pac_type_get_string (MbimStkPacType val);

Gets the nickname string for the MbimStkPacType specified at `val` .

#### Parameters

val | a MbimStkPacType. |

#### Returns

a string with the nickname, or `NULL` if not found. Do not free the returned value.

[transfer none]

Since: 1.4

### mbim_network_idle_hint_state_get_string ()

    const gchar *
    mbim_network_idle_hint_state_get_string
                                   (MbimNetworkIdleHintState val);

Gets the nickname string for the MbimNetworkIdleHintState specified at `val` .

#### Parameters

val | a MbimNetworkIdleHintState. |

#### Returns

a string with the nickname, or `NULL` if not found. Do not free the returned value.

[transfer none]

Since: 1.4

### mbim_emergency_mode_state_get_string ()

    const gchar *
    mbim_emergency_mode_state_get_string (MbimEmergencyModeState val);

Gets the nickname string for the MbimEmergencyModeState specified at `val` .

#### Parameters

val | a MbimEmergencyModeState. |

#### Returns

a string with the nickname, or `NULL` if not found. Do not free the returned value.

[transfer none]

Since: 1.4

### mbim_dss_link_state_get_string ()

    const gchar *
    mbim_dss_link_state_get_string (MbimDssLinkState val);

Gets the nickname string for the MbimDssLinkState specified at `val` .

#### Parameters

val | a MbimDssLinkState. |

#### Returns

a string with the nickname, or `NULL` if not found. Do not free the returned value.

[transfer none]

Since: 1.4

### mbim_atds_provider_plmn_mode_get_string ()

    const gchar *
    mbim_atds_provider_plmn_mode_get_string
                                   (MbimAtdsProviderPlmnMode val);

Gets the nickname string for the MbimAtdsProviderPlmnMode specified at `val` .

#### Parameters

val | a MbimAtdsProviderPlmnMode. |

#### Returns

a string with the nickname, or `NULL` if not found. Do not free the returned value.

[transfer none]

Since: 1.16

### mbim_atds_rat_mode_get_string ()

    const gchar *
    mbim_atds_rat_mode_get_string (MbimAtdsRatMode val);

Gets the nickname string for the MbimAtdsRatMode specified at `val` .

#### Parameters

val | a MbimAtdsRatMode. |

#### Returns

a string with the nickname, or `NULL` if not found. Do not free the returned value.

[transfer none]

Since: 1.16

### mbim_pco_type_get_string ()

    const gchar *
    mbim_pco_type_get_string (MbimPcoType val);

Gets the nickname string for the MbimPcoType specified at `val` .

#### Parameters

val | a MbimPcoType. |

#### Returns

a string with the nickname, or `NULL` if not found. Do not free the returned value.

[transfer none]

Since: 1.18

### mbim_context_source_get_string ()

    const gchar *
    mbim_context_source_get_string (MbimContextSource val);

Gets the nickname string for the MbimContextSource specified at `val` .

#### Parameters

val | a MbimContextSource. |

#### Returns

a string with the nickname, or `NULL` if not found. Do not free the returned value.

[transfer none]

Since: 1.18

### mbim_lte_attach_context_operation_get_string ()

    const gchar *
    mbim_lte_attach_context_operation_get_string
                                   (MbimLteAttachContextOperation val);

Gets the nickname string for the MbimLteAttachContextOperation specified at `val` .

#### Parameters

val | a MbimLteAttachContextOperation. |

#### Returns

a string with the nickname, or `NULL` if not found. Do not free the returned value.

[transfer none]

Since: 1.18

### mbim_lte_attach_context_roaming_control_get_string ()

    const gchar *
    mbim_lte_attach_context_roaming_control_get_string
                                   (MbimLteAttachContextRoamingControl val);

Gets the nickname string for the MbimLteAttachContextRoamingControl specified at `val` .

#### Parameters

val | a MbimLteAttachContextRoamingControl. |

#### Returns

a string with the nickname, or `NULL` if not found. Do not free the returned value.

[transfer none]

Since: 1.18

### mbim_lte_attach_state_get_string ()

    const gchar *
    mbim_lte_attach_state_get_string (MbimLteAttachState val);

Gets the nickname string for the MbimLteAttachState specified at `val` .

#### Parameters

val | a MbimLteAttachState. |

#### Returns

a string with the nickname, or `NULL` if not found. Do not free the returned value.

[transfer none]

Since: 1.18

### mbim_sar_backoff_state_get_string ()

    const gchar *
    mbim_sar_backoff_state_get_string (MbimSarBackoffState val);

Gets the nickname string for the MbimSarBackoffState specified at `val` .

#### Parameters

val | a MbimSarBackoffState. |

#### Returns

a string with the nickname, or `NULL` if not found. Do not free the returned value.

[transfer none]

Since: 1.26

### mbim_sar_control_mode_get_string ()

    const gchar *
    mbim_sar_control_mode_get_string (MbimSarControlMode val);

Gets the nickname string for the MbimSarControlMode specified at `val` .

#### Parameters

val | a MbimSarControlMode. |

#### Returns

a string with the nickname, or `NULL` if not found. Do not free the returned value.

[transfer none]

Since: 1.26

### mbim_sar_wifi_hardware_state_get_string ()

    const gchar *
    mbim_sar_wifi_hardware_state_get_string
                                   (MbimSarWifiHardwareState val);

Gets the nickname string for the MbimSarWifiHardwareState specified at `val` .

#### Parameters

val | a MbimSarWifiHardwareState. |

#### Returns

a string with the nickname, or `NULL` if not found. Do not free the returned value.

[transfer none]

Since: 1.26

### mbim_transmission_notification_status_get_string ()

    const gchar *
    mbim_transmission_notification_status_get_string
                                   (MbimTransmissionNotificationStatus val);

Gets the nickname string for the MbimTransmissionNotificationStatus specified at `val` .

#### Parameters

val | a MbimTransmissionNotificationStatus. |

#### Returns

a string with the nickname, or `NULL` if not found. Do not free the returned value.

[transfer none]

Since: 1.26

### mbim_transmission_state_get_string ()

    const gchar *
    mbim_transmission_state_get_string (MbimTransmissionState val);

Gets the nickname string for the MbimTransmissionState specified at `val` .

#### Parameters

val | a MbimTransmissionState. |

#### Returns

a string with the nickname, or `NULL` if not found. Do not free the returned value.

[transfer none]

Since: 1.26

### mbim_qdu_file_type_get_string ()

    const gchar *
    mbim_qdu_file_type_get_string (MbimQduFileType val);

Gets the nickname string for the MbimQduFileType specified at `val` .

#### Parameters

val | a MbimQduFileType. |

#### Returns

a string with the nickname, or `NULL` if not found. Do not free the returned value.

[transfer none]

Since: 1.26

### mbim_qdu_session_action_get_string ()

    const gchar *
    mbim_qdu_session_action_get_string (MbimQduSessionAction val);

Gets the nickname string for the MbimQduSessionAction specified at `val` .

#### Parameters

val | a MbimQduSessionAction. |

#### Returns

a string with the nickname, or `NULL` if not found. Do not free the returned value.

[transfer none]

Since: 1.26

### mbim_qdu_session_result_get_string ()

    const gchar *
    mbim_qdu_session_result_get_string (MbimQduSessionResult val);

Gets the nickname string for the MbimQduSessionResult specified at `val` .

#### Parameters

val | a MbimQduSessionResult. |

#### Returns

a string with the nickname, or `NULL` if not found. Do not free the returned value.

[transfer none]

Since: 1.26

### mbim_qdu_session_status_get_string ()

    const gchar *
    mbim_qdu_session_status_get_string (MbimQduSessionStatus val);

Gets the nickname string for the MbimQduSessionStatus specified at `val` .

#### Parameters

val | a MbimQduSessionStatus. |

#### Returns

a string with the nickname, or `NULL` if not found. Do not free the returned value.

[transfer none]

Since: 1.26

### mbim_qdu_session_type_get_string ()

    const gchar *
    mbim_qdu_session_type_get_string (MbimQduSessionType val);

Gets the nickname string for the MbimQduSessionType specified at `val` .

#### Parameters

val | a MbimQduSessionType. |

#### Returns

a string with the nickname, or `NULL` if not found. Do not free the returned value.

[transfer none]

Since: 1.26

### mbim_uicc_slot_state_get_string ()

    const gchar *
    mbim_uicc_slot_state_get_string (MbimUiccSlotState val);

Gets the nickname string for the MbimUiccSlotState specified at `val` .

#### Parameters

val | a MbimUiccSlotState. |

#### Returns

a string with the nickname, or `NULL` if not found. Do not free the returned value.

[transfer none]

Since: 1.26

### mbim_uicc_secure_messaging_get_string ()

    const gchar *
    mbim_uicc_secure_messaging_get_string (MbimUiccSecureMessaging val);

Gets the nickname string for the MbimUiccSecureMessaging specified at `val` .

#### Parameters

val | a MbimUiccSecureMessaging. |

#### Returns

a string with the nickname, or `NULL` if not found. Do not free the returned value.

[transfer none]

Since: 1.26

### mbim_uicc_class_byte_type_get_string ()

    const gchar *
    mbim_uicc_class_byte_type_get_string (MbimUiccClassByteType val);

Gets the nickname string for the MbimUiccClassByteType specified at `val` .

#### Parameters

val | a MbimUiccClassByteType. |

#### Returns

a string with the nickname, or `NULL` if not found. Do not free the returned value.

[transfer none]

Since: 1.26

### mbim_uicc_pass_through_action_get_string ()

    const gchar *
    mbim_uicc_pass_through_action_get_string
                                   (MbimUiccPassThroughAction val);

Gets the nickname string for the MbimUiccPassThroughAction specified at `val` .

#### Parameters

val | a MbimUiccPassThroughAction. |

#### Returns

a string with the nickname, or `NULL` if not found. Do not free the returned value.

[transfer none]

Since: 1.26

### mbim_uicc_pass_through_status_get_string ()

    const gchar *
    mbim_uicc_pass_through_status_get_string
                                   (MbimUiccPassThroughStatus val);

Gets the nickname string for the MbimUiccPassThroughStatus specified at `val` .

#### Parameters

val | a MbimUiccPassThroughStatus. |

#### Returns

a string with the nickname, or `NULL` if not found. Do not free the returned value.

[transfer none]

Since: 1.26

### mbim_quectel_radio_switch_state_get_string ()

    const gchar *
    mbim_quectel_radio_switch_state_get_string
                                   (MbimQuectelRadioSwitchState val);

Gets the nickname string for the MbimQuectelRadioSwitchState specified at `val` .

#### Parameters

val | a MbimQuectelRadioSwitchState. |

#### Returns

a string with the nickname, or `NULL` if not found. Do not free the returned value.

[transfer none]

Since: 1.26.2

## Types and Values

### enum MbimAtdsProviderPlmnMode

Provider PLMN mode.

#### Members

MBIM_ATDS_PROVIDER_PLMN_MODE_GSM | GSM. |
MBIM_ATDS_PROVIDER_PLMN_MODE_UTRAN | UTRAN (UMTS). |
MBIM_ATDS_PROVIDER_PLMN_MODE_LTE | LTE. |

Since: 1.16

### enum MbimAtdsRatMode

RAT mode preferences.

#### Members

MBIM_ATDS_RAT_MODE_AUTOMATIC | Automatic. |
MBIM_ATDS_RAT_MODE_2G_ONLY | 2G only. |
MBIM_ATDS_RAT_MODE_3G_ONLY | 3G only. |
MBIM_ATDS_RAT_MODE_4G_ONLY | 4G only. |

Since: 1.16

### enum MbimDeviceType

Type of device.

#### Members

MBIM_DEVICE_TYPE_UNKNOWN | Unknown type. |
MBIM_DEVICE_TYPE_EMBEDDED | Device is embedded in the system. |
MBIM_DEVICE_TYPE_REMOVABLE | Device is removable. |
MBIM_DEVICE_TYPE_REMOTE | Device is remote. |

Since: 1.0

### enum MbimCellularClass

Cellular class.

#### Members

MBIM_CELLULAR_CLASS_GSM | Device is 3GPP. |
MBIM_CELLULAR_CLASS_CDMA | Device is 3GPP2. |

Since: 1.0

### enum MbimVoiceClass

Voice class.

#### Members

MBIM_VOICE_CLASS_UNKNOWN | Unknown voice class. |
MBIM_VOICE_CLASS_NO_VOICE | Device doesn't support voice. |
MBIM_VOICE_CLASS_SEPARATED_VOICE_DATA | Device supports separate voice and data connections. |
MBIM_VOICE_CLASS_SIMULTANEOUS_VOICE_DATA | Device supports simultaneous voice and data connections. |

Since: 1.0

### enum MbimSimClass

SIM class.

#### Members

MBIM_SIM_CLASS_LOGICAL | No physical SIM. |
MBIM_SIM_CLASS_REMOVABLE | Physical removable SIM. |

Since: 1.0

### enum MbimDataClass

Data class.

#### Members

MBIM_DATA_CLASS_GPRS | GPRS. |
MBIM_DATA_CLASS_EDGE | EDGE. |
MBIM_DATA_CLASS_UMTS | UMTS. |
MBIM_DATA_CLASS_HSDPA | HSDPA. |
MBIM_DATA_CLASS_HSUPA | HSUPA. |
MBIM_DATA_CLASS_LTE | LTE. |
MBIM_DATA_CLASS_1XRTT | 1xRTT. |
MBIM_DATA_CLASS_1XEVDO | 1xEV-DO. |
MBIM_DATA_CLASS_1XEVDO_REVA | 1xEV-DO RevA |
MBIM_DATA_CLASS_1XEVDV | 1xEV-DV. |
MBIM_DATA_CLASS_3XRTT | 3xRTT. |
MBIM_DATA_CLASS_1XEVDO_REVB | 1xEV-DO RevB. |
MBIM_DATA_CLASS_UMB | UMB. |
MBIM_DATA_CLASS_CUSTOM | Custom. |

Since: 1.0

### enum MbimSmsCaps

SMS capabilities.

#### Members

MBIM_SMS_CAPS_PDU_RECEIVE | Can receive in PDU mode. |
MBIM_SMS_CAPS_PDU_SEND | Can send in PDU mode. |
MBIM_SMS_CAPS_TEXT_RECEIVE | Can receive in text mode. |
MBIM_SMS_CAPS_TEXT_SEND | Can send in text mode. |

Since: 1.0

### enum MbimCtrlCaps

Control capabilities.

#### Members

MBIM_CTRL_CAPS_REG_MANUAL | Device allows manual network selection. |
MBIM_CTRL_CAPS_HW_RADIO_SWITCH | Device has a hardware radio power switch. |
MBIM_CTRL_CAPS_CDMA_MOBILE_IP | The CDMA function supports Mobile IP. |
MBIM_CTRL_CAPS_CDMA_SIMPLE_IP | The CDMA function supports Simple IP. |
MBIM_CTRL_CAPS_MULTI_CARRIER | Device can work with multiple providers. |

Since: 1.0

### enum MbimSubscriberReadyState

Ready state of the subscriber.

#### Members

MBIM_SUBSCRIBER_READY_STATE_NOT_INITIALIZED | Not initialized. |
MBIM_SUBSCRIBER_READY_STATE_INITIALIZED | Initialized. |
MBIM_SUBSCRIBER_READY_STATE_SIM_NOT_INSERTED | SIM not inserted. |
MBIM_SUBSCRIBER_READY_STATE_BAD_SIM | Bad SIM. |
MBIM_SUBSCRIBER_READY_STATE_FAILURE | Failure. |
MBIM_SUBSCRIBER_READY_STATE_NOT_ACTIVATED | Not activated. |
MBIM_SUBSCRIBER_READY_STATE_DEVICE_LOCKED | Device locked. |

Since: 1.0

### enum MbimReadyInfoFlag

Flag specifying how the ready info is treated.

#### Members

MBIM_READY_INFO_FLAG_NONE | Device in normal mode. Since 1.16. |
MBIM_READY_INFO_FLAG_PROTECT_UNIQUE_ID | Request to avoid displaying subscriber ID. |

Since: 1.0

### enum MbimRadioSwitchState

Radio switch state.

#### Members

MBIM_RADIO_SWITCH_STATE_OFF | Radio is off. |
MBIM_RADIO_SWITCH_STATE_ON | Radio is on. |

Since: 1.0

### enum MbimPinType

PIN Types.

#### Members

MBIM_PIN_TYPE_UNKNOWN | Unknown or unset. |
MBIM_PIN_TYPE_CUSTOM | The PIN type is a custom type and is none of the other PIN types listed in this enumeration. |
MBIM_PIN_TYPE_PIN1 | The PIN1 key. |
MBIM_PIN_TYPE_PIN2 | The PIN2 key. |
MBIM_PIN_TYPE_DEVICE_SIM_PIN | The device to SIM key. |
MBIM_PIN_TYPE_DEVICE_FIRST_SIM_PIN | The device to very first SIM key. |
MBIM_PIN_TYPE_NETWORK_PIN | The network personalization key. |
MBIM_PIN_TYPE_NETWORK_SUBSET_PIN | The network subset personalization key. |
MBIM_PIN_TYPE_SERVICE_PROVIDER_PIN | The service provider (SP) personalization key. |
MBIM_PIN_TYPE_CORPORATE_PIN | The corporate personalization key. |
MBIM_PIN_TYPE_SUBSIDY_PIN | The subsidy unlock key. |
MBIM_PIN_TYPE_PUK1 | The Personal Identification Number1 Unlock Key (PUK1). |
MBIM_PIN_TYPE_PUK2 | The Personal Identification Number2 Unlock Key (PUK2). |
MBIM_PIN_TYPE_DEVICE_FIRST_SIM_PUK | The device to very first SIM PIN unlock key. |
MBIM_PIN_TYPE_NETWORK_PUK | The network personalization unlock key. |
MBIM_PIN_TYPE_NETWORK_SUBSET_PUK | The network subset personalization unlock key. |
MBIM_PIN_TYPE_SERVICE_PROVIDER_PUK | The service provider (SP) personalization unlock key. |
MBIM_PIN_TYPE_CORPORATE_PUK | The corporate personalization unlock key. |

Since: 1.0

### enum MbimPinState

PIN States.

#### Members

MBIM_PIN_STATE_UNLOCKED | The device does not require a PIN. |
MBIM_PIN_STATE_LOCKED | The device requires the user to enter a PIN. |

Since: 1.0

### enum MbimPinOperation

Operation to perform on the PIN.

#### Members

MBIM_PIN_OPERATION_ENTER | Enter the specified PIN into the device. |
MBIM_PIN_OPERATION_ENABLE | Enable the specified PIN. |
MBIM_PIN_OPERATION_DISABLE | Disable the specified PIN. |
MBIM_PIN_OPERATION_CHANGE | Change the specified PIN. |

Since: 1.0

### enum MbimPinMode

Whether the lock is enabled or disabled.

#### Members

MBIM_PIN_MODE_NOT_SUPPORTED | Not supported. |
MBIM_PIN_MODE_ENABLED | Enabled. |
MBIM_PIN_MODE_DISABLED | Disabled. |

Since: 1.0

### enum MbimPinFormat

Format of the expected PIN code.

#### Members

MBIM_PIN_FORMAT_UNKNOWN | Unknown format. |
MBIM_PIN_FORMAT_NUMERIC | Numeric-only format. |
MBIM_PIN_FORMAT_ALPHANUMERIC | Alphanumeric format. |

Since: 1.0

### enum MbimProviderState

State of the provider.

#### Members

MBIM_PROVIDER_STATE_UNKNOWN | Unknown. |
MBIM_PROVIDER_STATE_HOME | Home operator. |
MBIM_PROVIDER_STATE_FORBIDDEN | Provider blocked. |
MBIM_PROVIDER_STATE_PREFERRED | Provider is in the preferred list. |
MBIM_PROVIDER_STATE_VISIBLE | Provider is visible. |
MBIM_PROVIDER_STATE_REGISTERED | Currently registered to the provider. |
MBIM_PROVIDER_STATE_PREFERRED_MULTICARRIER | Provider is a preferred multicarrier network. |

Since: 1.2

### enum MbimVisibleProvidersAction

Type of action to perform when listing visible providers.

#### Members

MBIM_VISIBLE_PROVIDERS_ACTION_FULL_SCAN | Full scan. |
MBIM_VISIBLE_PROVIDERS_ACTION_RESTRICTED_SCAN | Locate preferred multicarrier providers. |

Since: 1.2

### enum MbimNwError

Network errors.

#### Members

MBIM_NW_ERROR_UNKNOWN | Unknown or unset error. |
MBIM_NW_ERROR_IMSI_UNKNOWN_IN_HLR | IMSI unknown in the HLR. |
MBIM_NW_ERROR_ILLEGAL_MS | Illegal MS. Since 1.10. |
MBIM_NW_ERROR_IMSI_UNKNOWN_IN_VLR | IMSI unknown in the VLR. |
MBIM_NW_ERROR_IMEI_NOT_ACCEPTED | IMEI not accepted. Since 1.10. |
MBIM_NW_ERROR_ILLEGAL_ME | Illegal ME. |
MBIM_NW_ERROR_GPRS_NOT_ALLOWED | GPRS not allowed. |
MBIM_NW_ERROR_GPRS_AND_NON_GPRS_NOT_ALLOWED | GPRS and non-GPRS not allowed. |
MBIM_NW_ERROR_MS_IDENTITY_NOT_DERIVED_BY_NETWORK | MS identity cannot be derived by the network. Since 1.10. |
MBIM_NW_ERROR_IMPLICITLY_DETACHED | Implicitly detached. Since 1.10. |
MBIM_NW_ERROR_PLMN_NOT_ALLOWED | PLMN not allowed. |
MBIM_NW_ERROR_LOCATION_AREA_NOT_ALLOWED | Location area not allowed. |
MBIM_NW_ERROR_ROAMING_NOT_ALLOWED_IN_LOCATION_AREA | Roaming not allowed in the location area. |
MBIM_NW_ERROR_GPRS_NOT_ALLOWED_IN_PLMN | GPRS not allowed in PLMN. |
MBIM_NW_ERROR_NO_CELLS_IN_LOCATION_AREA | No cells in location area. |
MBIM_NW_ERROR_MSC_TEMPORARILY_NOT_REACHABLE | MSC temporarily not reachable. Since 1.10. |
MBIM_NW_ERROR_NETWORK_FAILURE | Network failure. |
MBIM_NW_ERROR_MAC_FAILURE | MAC failure. Since 1.10. |
MBIM_NW_ERROR_SYNCH_FAILURE | Synch failure. Since 1.10. |
MBIM_NW_ERROR_CONGESTION | Congestion. |
MBIM_NW_ERROR_GSM_AUTHENTICATION_UNACCEPTABLE | GSM authentication unacceptable. Since 1.10. |
MBIM_NW_ERROR_NOT_AUTHORIZED_FOR_CSG | Not authorized for this CSG. Since 1.10. |
MBIM_NW_ERROR_INSUFFICIENT_RESOURCES | Insufficient resources. Since 1.18. |
MBIM_NW_ERROR_MISSING_OR_UNKNOWN_APN | Missing or unknown access point name. Since 1.10. |
MBIM_NW_ERROR_UNKNOWN_PDP_ADDRESS_OR_TYPE | Unknown PDP address or PDP type. Since 1.18. |
MBIM_NW_ERROR_USER_AUTHENTICATION_FAILED | User authentication failed. Since 1.18. |
MBIM_NW_ERROR_ACTIVATION_REJECTED_BY_GGSN_OR_GW | Activation rejected by GGSN, Serving GW or PDN GW. Since 1.18. |
MBIM_NW_ERROR_ACTIVATION_REJECTED_UNSPECIFIED | Activation rejected, unspecified. Since 1.18. |
MBIM_NW_ERROR_SERVICE_OPTION_NOT_SUPPORTED | Service option not supported. Since 1.10. |
MBIM_NW_ERROR_REQUESTED_SERVICE_OPTION_NOT_SUBSCRIBED | Requested service option not subscribed. Since 1.10. |
MBIM_NW_ERROR_SERVICE_OPTION_TEMPORARILY_OUT_OF_ORDER | Service option temporarily out of order. Since 1.10. |
MBIM_NW_ERROR_NO_PDP_CONTEXT_ACTIVATED | No PDP context activated. Since 1.10. |
MBIM_NW_ERROR_PDP_TYPE_IPV4_ONLY_ALLOWED | PDP type IPv4 only allowed. Since 1.18. |
MBIM_NW_ERROR_PDP_TYPE_IPV6_ONLY_ALLOWED | PDP type IPv6 only allowed. Since 1.18. |
MBIM_NW_ERROR_MAXIMUM_NUMBER_OF_PDP_CONTEXTS_REACHED | Maximum number of PDP contexts reached. Since 1.18. |
MBIM_NW_ERROR_REQUESTED_APN_NOT_SUPPORTED_IN_CURRENT_RAT_AND_PLMN | Requested APN not supported in current RAT and PLMN combination. Since 1.18. |
MBIM_NW_ERROR_SEMANTICALLY_INCORRECT_MESSAGE | Semantically incorrect message. Since 1.10. |
MBIM_NW_ERROR_INVALID_MANDATORY_INFORMATION | Invalid mandatory information. Since 1.10. |
MBIM_NW_ERROR_MESSAGE_TYPE_NON_EXISTENT_OR_NOT_IMPLEMENTED | Message type non-existent or not implemented. Since 1.10. |
MBIM_NW_ERROR_MESSAGE_TYPE_NOT_COMPATIBLE_WITH_PROTOCOL_STATE | Message type not compatible with protocol state. Since 1.10. |
MBIM_NW_ERROR_INFORMATION_ELEMENT_NON_EXISTENT_OR_NOT_IMPLEMENTED | Information element non-existent or not implemented. Since 1.10. |
MBIM_NW_ERROR_CONDITIONAL_IE_ERROR | Conditional IE error. Since 1.10. |
MBIM_NW_ERROR_MESSAGE_NOT_COMPATIBLE_WITH_PROTOCOL_STATE | Message not compatible with protocol state. Since 1.10. |
MBIM_NW_ERROR_PROTOCOL_ERROR_UNSPECIFIED | Protocol error, unspecified. Since 1.10. |
MBIM_NW_ERROR_APN_RESTRICTION_VALUE_INCOMPATIBLE_WITH_ACTIVE_PDP_CONTEXT | APN restriction value incompatible with active PDP context. Since 1.18. |
MBIM_NW_ERROR_MULTIPLE_ACCESSES_TO_A_PDN_CONNECTION_NOT_ALLOWED | Multiple accesses to a PDN connection not allowed. Since 1.18. |

Since: 1.0

### enum MbimRegisterAction

Type of registration requested.

#### Members

MBIM_REGISTER_ACTION_AUTOMATIC | Automatic registration. |
MBIM_REGISTER_ACTION_MANUAL | Manual registration. |

Since: 1.0

### enum MbimRegisterState

Registration state.

#### Members

MBIM_REGISTER_STATE_UNKNOWN | Unknown registration state. |
MBIM_REGISTER_STATE_DEREGISTERED | Not registered. |
MBIM_REGISTER_STATE_SEARCHING | Searching. |
MBIM_REGISTER_STATE_HOME | Registered in home network. |
MBIM_REGISTER_STATE_ROAMING | Registered in roaming network. |
MBIM_REGISTER_STATE_PARTNER | Registered in a preferred roaming network. |
MBIM_REGISTER_STATE_DENIED | Registration denied. |

Since: 1.0

### enum MbimRegisterMode

Type of registration requested.

#### Members

MBIM_REGISTER_MODE_UNKNOWN | Unknown. |
MBIM_REGISTER_MODE_AUTOMATIC | Automatic registration. |
MBIM_REGISTER_MODE_MANUAL | Manual registration. |

Since: 1.0

### enum MbimRegistrationFlag

Registration flags.

#### Members

MBIM_REGISTRATION_FLAG_NONE | None. |
MBIM_REGISTRATION_FLAG_MANUAL_SELECTION_NOT_AVAILABLE | Network doesn't support manual network selection. |
MBIM_REGISTRATION_FLAG_PACKET_SERVICE_AUTOMATIC_ATTACH | Modem should auto-attach to the network after registration. Since 1.8. |

Since: 1.0

### enum MbimPacketServiceAction

Packet Service Action.

#### Members

MBIM_PACKET_SERVICE_ACTION_ATTACH | Attach. |
MBIM_PACKET_SERVICE_ACTION_DETACH | Detach. |

Since: 1.0

### enum MbimPacketServiceState

Packet Service State.

#### Members

MBIM_PACKET_SERVICE_STATE_UNKNOWN | Unknown. |
MBIM_PACKET_SERVICE_STATE_ATTACHING | Attaching. |
MBIM_PACKET_SERVICE_STATE_ATTACHED | Attached. |
MBIM_PACKET_SERVICE_STATE_DETACHING | Detaching. |
MBIM_PACKET_SERVICE_STATE_DETACHED | Detached. |

Since: 1.0

### enum MbimActivationCommand

Activation Command.

#### Members

MBIM_ACTIVATION_COMMAND_DEACTIVATE | Deactivate. |
MBIM_ACTIVATION_COMMAND_ACTIVATE | Activate. |

Since: 1.0

### enum MbimCompression

Compression.

#### Members

MBIM_COMPRESSION_NONE | None. |
MBIM_COMPRESSION_ENABLE | Enable. |

Since: 1.0

### enum MbimAuthProtocol

Auth Protocol.

#### Members

MBIM_AUTH_PROTOCOL_NONE | None. |
MBIM_AUTH_PROTOCOL_PAP | Pap. |
MBIM_AUTH_PROTOCOL_CHAP | Chap. |
MBIM_AUTH_PROTOCOL_MSCHAPV2 | V2. |

Since: 1.0

### enum MbimContextIpType

Context IP Type.

#### Members

MBIM_CONTEXT_IP_TYPE_DEFAULT | It is up to the function to decide, the host does not care. |
MBIM_CONTEXT_IP_TYPE_IPV4 | IPv4 context. |
MBIM_CONTEXT_IP_TYPE_IPV6 | IPv6 context. |
MBIM_CONTEXT_IP_TYPE_IPV4V6 | The context is IPv4, IPv6 or dualstack IPv4v6. |
MBIM_CONTEXT_IP_TYPE_IPV4_AND_IPV6 | Both an IPv4 and an IPv6 context. |

Since: 1.0

### enum MbimActivationState

Activation State.

#### Members

MBIM_ACTIVATION_STATE_UNKNOWN | Unknown. |
MBIM_ACTIVATION_STATE_ACTIVATED | Activated. |
MBIM_ACTIVATION_STATE_ACTIVATING | Activating. |
MBIM_ACTIVATION_STATE_DEACTIVATED | Deactivated. |
MBIM_ACTIVATION_STATE_DEACTIVATING | Deactivating. |

Since: 1.0

### enum MbimVoiceCallState

Voice Call State.

#### Members

MBIM_VOICE_CALL_STATE_NONE | None. |
MBIM_VOICE_CALL_STATE_IN_PROGRESS | Progress. |
MBIM_VOICE_CALL_STATE_HANG_UP | Up. |

Since: 1.0

### enum MbimIPConfigurationAvailableFlag

Mask of available information about an IP address.

#### Members

MBIM_IP_CONFIGURATION_AVAILABLE_FLAG_NONE | No info available. |
MBIM_IP_CONFIGURATION_AVAILABLE_FLAG_ADDRESS | Address info available. |
MBIM_IP_CONFIGURATION_AVAILABLE_FLAG_GATEWAY | Gateway info available. |
MBIM_IP_CONFIGURATION_AVAILABLE_FLAG_DNS | DNS info available. |
MBIM_IP_CONFIGURATION_AVAILABLE_FLAG_MTU | MTU info available. |

Since: 1.0

### enum MbimSmsStorageState

State of the SMS storage.

#### Members

MBIM_SMS_STORAGE_STATE_NOT_INITIALIZED | Storage not initialized. |
MBIM_SMS_STORAGE_STATE_INITIALIZED | Storage initialized. |

Since: 1.4

### enum MbimSmsFormat

SMS format.

#### Members

MBIM_SMS_FORMAT_PDU | PDU format. |
MBIM_SMS_FORMAT_CDMA | CDMA format. |

Since: 1.4

### enum MbimSmsFlag

Flags to use when requesting to read SMS. `MBIM_SMS_FLAG_ALL` and `MBIM_SMS_FLAG_NEW` are mandatory, all the others are optional.

#### Members

MBIM_SMS_FLAG_ALL | All. |
MBIM_SMS_FLAG_INDEX | Index. |
MBIM_SMS_FLAG_NEW | New. |
MBIM_SMS_FLAG_OLD | Old. |
MBIM_SMS_FLAG_SENT | Sent. |
MBIM_SMS_FLAG_DRAFT | Draft. |

Since: 1.4

### enum MbimSmsCdmaLang

Language of a CDMA SMS.

#### Members

MBIM_SMS_CDMA_LANG_UNKNOWN | Unknown language. |
MBIM_SMS_CDMA_LANG_ENGLISH | English. |
MBIM_SMS_CDMA_LANG_FRENCH | French. |
MBIM_SMS_CDMA_LANG_SPANISH | Spanish. |
MBIM_SMS_CDMA_LANG_JAPANESE | Japanese. |
MBIM_SMS_CDMA_LANG_KOREAN | Korean. |
MBIM_SMS_CDMA_LANG_CHINESE | Chinese. |
MBIM_SMS_CDMA_LANG_HEBREW | Hebrew. |

Since: 1.4

### enum MbimSmsCdmaEncoding

Type of encoding of a CDMA SMS.

#### Members

MBIM_SMS_CDMA_ENCODING_OCTET | Octet. |
MBIM_SMS_CDMA_ENCODING_EPM | EPM. |
MBIM_SMS_CDMA_ENCODING_7BIT_ASCII | 7-bit ASCII. |
MBIM_SMS_CDMA_ENCODING_LA5 | LA5. |
MBIM_SMS_CDMA_ENCODING_UNICODE | Unicode. |
MBIM_SMS_CDMA_ENCODING_SHIFT_JIS | Shift JIS. |
MBIM_SMS_CDMA_ENCODING_KOREAN | Korean. |
MBIM_SMS_CDMA_ENCODING_LATIN_HEBREW | Latin hebrew. |
MBIM_SMS_CDMA_ENCODING_LATIN | Latin. |
MBIM_SMS_CDMA_ENCODING_GSM_7BIT | 7-bit GSM. |

Since: 1.4

### enum MbimSmsStatus

Status of a SMS message.

#### Members

MBIM_SMS_STATUS_NEW | New. |
MBIM_SMS_STATUS_OLD | Old. |
MBIM_SMS_STATUS_DRAFT | Draft. |
MBIM_SMS_STATUS_SENT | Sent. |

Since: 1.4

### enum MbimSmsStatusFlag

SMS status flags.

#### Members

MBIM_SMS_STATUS_FLAG_NONE | None. |
MBIM_SMS_STATUS_FLAG_MESSAGE_STORE_FULL | Message store is full. |
MBIM_SMS_STATUS_FLAG_NEW_MESSAGE | New non-Class 0 message arrived. |

Since: 1.4

### enum MbimUssdAction

USSD action.

#### Members

MBIM_USSD_ACTION_INITIATE | Initiate USSD session. |
MBIM_USSD_ACTION_CONTINUE | Continue USSD session. |
MBIM_USSD_ACTION_CANCEL | Cancel USSD session. |

Since: 1.4

### enum MbimUssdResponse

USSD response.

#### Members

MBIM_USSD_RESPONSE_NO_ACTION_REQUIRED | No action required. |
MBIM_USSD_RESPONSE_ACTION_REQUIRED | An action is required. |
MBIM_USSD_RESPONSE_TERMINATED_BY_NETWORK | Terminated by network |
MBIM_USSD_RESPONSE_OTHER_LOCAL_CLIENT | Other local client. |
MBIM_USSD_RESPONSE_OPERATION_NOT_SUPPORTED | Operation not supported. |
MBIM_USSD_RESPONSE_NETWORK_TIMEOUT | Network timeout. |

Since: 1.4

### enum MbimUssdSessionState

Session state.

#### Members

MBIM_USSD_SESSION_STATE_NEW_SESSION | New session. |
MBIM_USSD_SESSION_STATE_EXISTING_SESSION | Existing session. |

Since: 1.4

### enum MbimPhonebookFlag

Flags to use when reading the phonebook.

#### Members

MBIM_PHONEBOOK_FLAG_ALL | Request all. |
MBIM_PHONEBOOK_FLAG_INDEX | Request single entry by index. |

Since: 1.4

### enum MbimPhonebookState

Phonebook state.

#### Members

MBIM_PHONEBOOK_STATE_NOT_INITIALIZED | Not initialized. |
MBIM_PHONEBOOK_STATE_INITIALIZED | Initialized |

Since: 1.4

### enum MbimPhonebookWriteFlag

Flags to use when writing the phonebook.

#### Members

MBIM_PHONEBOOK_WRITE_FLAG_SAVE_UNUSED | Store the record in an unused slot. |
MBIM_PHONEBOOK_WRITE_FLAG_SAVE_INDEX | Index where to store the record. |

Since: 1.4

### enum MbimStkPacProfile

Proactive command profile.

#### Members

MBIM_STK_PAC_PROFILE_NOT_HANDLED_BY_FUNCTION_HANDLED_BY_HOST | Command not handled by function but handled by host. |
MBIM_STK_PAC_PROFILE_NOT_HANDLED_BY_FUNCTION_MAY_BE_HANDLED_BY_HOST | Command not handled by function but may be handled by host. |
MBIM_STK_PAC_PROFILE_HANDLED_BY_FUNCTION_ONLY_TRANSPARENT_TO_HOST | Command handled by function without informing the host. |
MBIM_STK_PAC_PROFILE_HANDLED_BY_FUNCTION_NOTIFICATION_TO_HOST_POSSIBLE | Command handled by function without informing the host, but notifications may be sent to host. |
MBIM_STK_PAC_PROFILE_HANDLED_BY_FUNCTION_NOTIFICATIONS_TO_HOST_ENABLED | Command handled by function, and the function wil also send notification to the host. |
MBIM_STK_PAC_PROFILE_HANDLED_BY_FUNCTION_CAN_BE_OVERRIDEN_BY_HOST | Command handled by function, but the host may request full control of the command. |
MBIM_STK_PAC_PROFILE_HANDLED_BY_HOST_FUNCTION_NOT_ABLE_TO_HANDLE | Command will be forwarded to the host. If the host decides not to receive the command, the function will not handle it. |
MBIM_STK_PAC_PROFILE_HANDLED_BY_HOST_FUNCTION_ABLE_TO_HANDLE | Command will be forwarded to the host. If the host decides not to receive the command, the function will handle it. |

Since: 1.4

### enum MbimStkPacType

Type of proactive command.

#### Members

MBIM_STK_PAC_TYPE_PROACTIVE_COMMAND | Host is requested to handle the Proactive command. |
MBIM_STK_PAC_TYPE_NOTIFICATION | Proactive command is handled by the function, but the host is notified. |

Since: 1.4

### enum MbimNetworkIdleHintState

Enable or disable network idle hint.

#### Members

MBIM_NETWORK_IDLE_HINT_STATE_DISABLED | Disabled. |
MBIM_NETWORK_IDLE_HINT_STATE_ENABLED | Enabled. |

Since: 1.4

### enum MbimEmergencyModeState

Emergency mode state.

#### Members

MBIM_EMERGENCY_MODE_STATE_OFF | Off. |
MBIM_EMERGENCY_MODE_STATE_ON | On. |

Since: 1.4

### enum MbimDssLinkState

Action performed in the link state.

#### Members

MBIM_DSS_LINK_STATE_DEACTIVATE | Deactivate. |
MBIM_DSS_LINK_STATE_ACTIVATE | Activate. |

Since: 1.4

### enum MbimQduFileType

QDU session result.

#### Members

MBIM_QDU_FILE_TYPE_LITTLE_ENDIAN_PACKAGE | LE Package |

Since: 1.26

### enum MbimQduSessionAction

Action performed for the session initialization.

#### Members

MBIM_QDU_SESSION_ACTION_START | Start. |
MBIM_QDU_SESSION_ACTION_STOP | Stop. |

Since: 1.26

### enum MbimQduSessionType

QDU session types.

#### Members

MBIM_QDU_SESSION_TYPE_NONE | No update session. |
MBIM_QDU_SESSION_TYPE_LE | LE-based update procedure. |

Since: 1.26

### enum MbimQduSessionStatus

QDU session status.

#### Members

MBIM_QDU_SESSION_STATUS_INACTIVE | Update session is not active. |
MBIM_QDU_SESSION_STATUS_FILE_TRANSFER | Updated files are being transferred from host to function or function is waiting host to send updated files. |
MBIM_QDU_SESSION_STATUS_APPLY_UPDATE | The function is applying the update package. |

Since: 1.26

### enum MbimQduSessionResult

QDU session result.

#### Members

MBIM_QDU_SESSION_RESULT_SUCCESS | Success |
MBIM_QDU_SESSION_RESULT_FAILURE | Failure |

Since: 1.26

### enum MbimPcoType

Type of PCO structure.

#### Members

MBIM_PCO_TYPE_COMPLETE | The PCO structure is complete. |
MBIM_PCO_TYPE_PARTIAL | The PCO structure is a subset of what was received from the network. |

Since: 1.18

### enum MbimContextSource

Source of context creation.

#### Members

MBIM_CONTEXT_SOURCE_ADMIN | Context created by enterprise IT. |
MBIM_CONTEXT_SOURCE_USER | Context created by user. |
MBIM_CONTEXT_SOURCE_OPERATOR | Context created by operator. |
MBIM_CONTEXT_SOURCE_MODEM | Context created by modem manufacturer. |
MBIM_CONTEXT_SOURCE_DEVICE | Context created by OS APN database. |

Since: 1.18

### enum MbimLteAttachContextOperation

Command to run when updating LTE attach configuration.

#### Members

MBIM_LTE_ATTACH_CONTEXT_OPERATION_DEFAULT | Overwrite existing contexts. |
MBIM_LTE_ATTACH_CONTEXT_OPERATION_RESTORE_FACTORY | Restore factory preconfigured contexts. |

Since: 1.18

### enum MbimLteAttachContextRoamingControl

Type of roaming control.

#### Members

MBIM_LTE_ATTACH_CONTEXT_ROAMING_CONTROL_HOME | Context allowed to be used on home network. |
MBIM_LTE_ATTACH_CONTEXT_ROAMING_CONTROL_PARTNER | Context allowed to be used on partner network. |
MBIM_LTE_ATTACH_CONTEXT_ROAMING_CONTROL_NON_PARTNER | Context allowed to be used on non-partner network. |

Since: 1.18

### enum MbimLteAttachState

LTE attach state.

#### Members

MBIM_LTE_ATTACH_STATE_DETACHED | Detached. |
MBIM_LTE_ATTACH_STATE_ATTACHED | Attached. |

Since: 1.18

### enum MbimSarBackoffState

SAR backoff state.

#### Members

MBIM_SAR_BACKOFF_STATE_DISABLED | SAR backoff is disabled. |
MBIM_SAR_BACKOFF_STATE_ENABLED | SAR backoff is enabled. |

Since: 1.26

### enum MbimSarControlMode

SAR backoff mechanism control modes.

#### Members

MBIM_SAR_CONTROL_MODE_DEVICE | SAR backoff is controlled by the modem directly. |
MBIM_SAR_CONTROL_MODE_OS | SAR backoff is controlled by the host operating system. |

Since: 1.26

### enum MbimSarWifiHardwareState

Whether the Wi-Fi and cellular SAR are integrated at hardware level.

#### Members

MBIM_SAR_WIFI_HARDWARE_STATE_INTEGRATED | Integrated. |
MBIM_SAR_WIFI_HARDWARE_STATE_NOT_INTEGRATED | Not integrated. |

Since: 1.26

### enum MbimTransmissionNotificationStatus

Whether modem channel transmission status notification is disabled or enabled.

#### Members

MBIM_TRANSMISSION_NOTIFICATION_STATUS_DISABLED | Notification disabled. |
MBIM_TRANSMISSION_NOTIFICATION_STATUS_ENABLED | Notification enabled. |

Since: 1.26

### enum MbimTransmissionState

Whether modem is having TX traffic every hysteresis timeout.

#### Members

MBIM_TRANSMISSION_STATE_INACTIVE | Modem was not actively transmitting data. |
MBIM_TRANSMISSION_STATE_ACTIVE | Modem was actively transmitting data. |

Since: 1.26

### enum MbimUiccSlotState

MbimUiccSlotState

#### Members

MBIM_UICC_SLOT_STATE_UNKNOWN | The modem is still in the process of initializing so the SIM slot state is not deterministic. |
MBIM_UICC_SLOT_SATE_OFF_EMPTY | The UICC slot is powered off and no card is present. |
MBIM_UICC_SLOT_STATE_OFF | The UICC slot is powered off. |
MBIM_UICC_SLOT_STATE_EMPTY | The UICC slot is empty(there is no card in it). |
MBIM_UICC_SLOT_STATE_NOT_READY | The UICC slot is occupied and powered on but the card within it is not yet ready. |
MBIM_UICC_SLOT_STATE_ACTIVE | The UICC slot is occupied and the card within it is ready. |
MBIM_UICC_SLOT_STATE_ERROR | The UICC slot is occupied and powreed on but the card is in an error state and cannot be used until it is next reset. |
MBIM_UICC_SLOT_STATE_ACTIVE_ESIM | The card in the slot is an eSIM with an active profile and is ready to accept commands. |
MBIM_UICC_SLOT_STATE_ACTIVE_ESIM_NO_PROFILES | The card in the slot is an eSIM with no profiles(or no active profiles) and is ready to accept commands. |

Since: 1.26

### enum MbimUiccSecureMessaging

Specifies whether apdu is exchanged using secure messaging.

#### Members

MBIM_UICC_SECURE_MESSAGING_NONE | No secure messaging. |
MBIM_UICC_SECURE_MESSAGING_NO_HDR_AUTH | Secure, command header not authenticated. |

Since: 1.26

### enum MbimUiccClassByteType

Specifies the type of class byte definition.

#### Members

MBIM_UICC_CLASS_BYTE_TYPE_INTER_INDUSTRY | Defined according to first interindustry definition in ISO 7816-4. |
MBIM_UICC_CLASS_BYTE_TYPE_EXTENDED | Defined according to extended definition in ETSI 102 221. |

Since: 1.26

### enum MbimUiccPassThroughAction

Pass through actions host can specify to modem. Upon reset treats UICC as if pass through or as a regular UICC

#### Members

MBIM_UICC_PASS_THROUGH_ACTION_DISABLE | Disable pass through. |
MBIM_UICC_PASS_THROUGH_ACTION_ENABLE | Enable pass through. |

Since: 1.26

### enum MbimUiccPassThroughStatus

Pass through status of the modem specifies to the host.

#### Members

MBIM_UICC_PASS_THROUGH_STATUS_DISABLED | Pass through disabled. |
MBIM_UICC_PASS_THROUGH_STATUS_ENABLED | Pass through enabled. |

Since: 1.26

### enum MbimQuectelRadioSwitchState

Radio switch state.

#### Members

MBIM_QUECTEL_RADIO_SWITCH_STATE_OFF | Radio is off. |
MBIM_QUECTEL_RADIO_SWITCH_STATE_ON | Radio is on. |
MBIM_QUECTEL_RADIO_SWITCH_STATE_FCC_LOCKED | Radio is FCC locked. |

Since: 1.26.2